<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE mapper
PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN"
"http://mybatis.org/dtd/mybatis-3-mapper.dtd">
<mapper namespace="com.goomood.phm.mapper.BasicDeviceInfoMapper">
    
    <resultMap type="BasicDeviceInfo" id="BasicDeviceInfoResult">
        <result property="id"    column="id"    />
        <result property="typeId"    column="type_id"    />
        <result property="name"    column="name"    />
        <result property="description"    column="description"    />
        <result property="createBy"    column="create_by"    />
        <result property="createTime"    column="create_time"    />
        <result property="updateBy"    column="update_by"    />
        <result property="updateTime"    column="update_time"    />
        <result property="remark"    column="remark"    />
    </resultMap>

    <sql id="selectBasicDeviceInfoVo">
        select id, type_id, name, description, create_by, create_time, update_by, update_time, remark from basic_device_info
    </sql>

    <select id="selectBasicDeviceInfoList" parameterType="BasicDeviceInfo" resultMap="BasicDeviceInfoResult">
        <include refid="selectBasicDeviceInfoVo"/>
        <where>  
            <if test="name != null  and name != ''"> and name like concat('%', #{name}, '%')</if>
            <if test="typeId != null"> and type_Id = #{typeId} </if>
        </where>
    </select>
    
    <select id="selectBasicDeviceInfoById" parameterType="Long" resultMap="BasicDeviceInfoResult">
        <include refid="selectBasicDeviceInfoVo"/>
        where id = #{id}
    </select>

    <insert id="insertBasicDeviceInfo" parameterType="BasicDeviceInfo" useGeneratedKeys="true" keyProperty="id">
        insert into basic_device_info
        <trim prefix="(" suffix=")" suffixOverrides=",">
            <if test="typeId != null">type_id,</if>
            <if test="name != null and name != ''">name,</if>
            <if test="description != null">description,</if>
            <if test="createBy != null">create_by,</if>
            <if test="createTime != null">create_time,</if>
            <if test="updateBy != null">update_by,</if>
            <if test="updateTime != null">update_time,</if>
            <if test="remark != null">remark,</if>
         </trim>
        <trim prefix="values (" suffix=")" suffixOverrides=",">
            <if test="typeId != null">#{typeId},</if>
            <if test="name != null and name != ''">#{name},</if>
            <if test="description != null">#{description},</if>
            <if test="createBy != null">#{createBy},</if>
            <if test="createTime != null">#{createTime},</if>
            <if test="updateBy != null">#{updateBy},</if>
            <if test="updateTime != null">#{updateTime},</if>
            <if test="remark != null">#{remark},</if>
         </trim>
    </insert>

    <update id="updateBasicDeviceInfo" parameterType="BasicDeviceInfo">
        update basic_device_info
        <trim prefix="SET" suffixOverrides=",">
            <if test="typeId != null">type_id = #{typeId},</if>
            <if test="name != null and name != ''">name = #{name},</if>
            <if test="description != null">description = #{description},</if>
            <if test="createBy != null">create_by = #{createBy},</if>
            <if test="createTime != null">create_time = #{createTime},</if>
            <if test="updateBy != null">update_by = #{updateBy},</if>
            <if test="updateTime != null">update_time = #{updateTime},</if>
            <if test="remark != null">remark = #{remark},</if>
        </trim>
        where id = #{id}
    </update>

    <delete id="deleteBasicDeviceInfoById" parameterType="Long">
        delete from basic_device_info where id = #{id}
    </delete>

    <delete id="deleteBasicDeviceInfoByIds" parameterType="String">
        delete from basic_device_info where id in 
        <foreach item="id" collection="array" open="(" separator="," close=")">
            #{id}
        </foreach>
    </delete>
</mapper>